*-----------------------------------------------------------
* Program    : Final Project
* Written by : Laron Anderson
* Date       : 
* Description: Craps Game

* Trap code 8 returns time in hundredths of a second since midnight in D1.L

*-------------------------------------------------------------
	ORG	$1000
START:				; first instruction of program
*-------------------------------------------------------------
*Clear Data register(s) for multiple runs
	CLR	D7
*-------------------------------------------------------------
*Prompt user input
	LEA	prompt1,A1
	BSR	TASK95
*-------------------------------------------------------------
*Set cursor position
	MOVE.W	#0002,D1
	MOVE.B	#11,D0
	TRAP	#15
*-------------------------------------------------------------
*Accept user input
	CLR.W	D1
	MOVE.B	#5,D0
	TRAP	#15
*-------------------------------------------------------------
*Evaluate user input

 if.b d1 <EQ> #$72 then		; if the byte in register d1 is equal to the ASCII code for 'r' 	
	BSR	DICEPREP	; Prepare the dicer		
	BSR	rand1		; branch to the subroutine 'rand1'
  else
 	BRA	END
 endi
*-------------------------------------------------------------
*The random number generator will leave a random number in either D1.L, D1.W, or D1.B
	BSR	firstIfSet

*-----------------------------------------------------------------------	
	*Delay the time between the generation of the first and second random numbers
	
	MOVE.L	#50,D1		; delay the animation 50/100 of a second
	MOVE	#23,D0		; delay task
	TRAP	#15
*-----------------------------------------------------------------------
*Generate another random number
	BSR	rand2
*-------------------------------------------------------------
	BSR	SecondIfSet
*--------------------------------------------------------------
*Get the sum of the two random numbers
	ADD	D5,D6	
*--------------------------------------------------------------
*Use a series of 'if' statements that examine D6 and determine craps, point, or win

 *Rolls in which a point is established:
 *First roll is a 4
 if.b d6 <EQ> #$4 then
 	bsr	point
 endi
 
 if.b d6 <EQ> #$5 then
 	bsr	point
 endi
 
 if.b d6 <EQ> #$6 then
 	bsr	point
 endi
 
 if.b d6 <EQ> #$8 then
 	bsr	point
 endi
 
 if.b d6 <EQ> #$9 then
 	bsr	point
 endi
 
 if.b d6 <EQ> #$A then
 	bsr	point
 endi
*-----------------------------------------------------------
*End of rolls which establish a "point"
*-----------------------------------------------------------
 *First roll is a 7
 if.w d6 <EQ> #$7 then
 	LEA 	win,A1
	BSR	TASK95
 endi
	
 *First roll is an 11
 if.w d6 <EQ> #$B then
 	LEA	win,A1
	BSR	TASK95
 endi
 
 *First roll is a 12
 if.w d6 <EQ> #$C then
 	LEA	lose1,A1
	BSR	TASK95
 endi
 
 *First roll is a 2
 if.w d6 <EQ> #$2 then
  	LEA	lose2,A1
	BSR	TASK95
 endi
 
 *First roll is a 3
 if.w d6 <EQ> #$3 then
 	LEA	lose1,A1
	BSR	TASK95
 endi
 *-------------------------------------------------------------
 	
	*Set cursor position
	MOVE.W	#0002,D1
	MOVE.B	#11,D0
	TRAP	#15
	
	*Read string from keyboard
	
	MOVE.B	#5,D0
	TRAP	#15
	
	if.b D1 <EQ> #$79 then		; if d1.b equal the ASCII code for 'y'
		
		bra	START
	else
		bra	END
	endi

*-------------------------------------------------------------
*End the execution of the program
END	STOP	#$2700
*-------------------------------------------------------------
CLRPOINT
	*Clear the number value for the "point" display

	MOVE.W	#$091D,D1	; Set cursor position (HEX WORKS BEST FOR TASK 11!)
	MOVE.B	#11,D0
	TRAP	#15
	
	LEA	TWODEL,A1
	MOVE.B	#0,D0
	TRAP	#15
	
	*Clear the text for "point"
	
	LEA	blank,A1
	MOVE.W	#0,D1
	MOVE.W	#435,D2
	MOVE.B	#95,D0
	TRAP #15

	RTS
*-------------------------------------------------------------
*Task 95 (Display text as a graphic)
TASK95		
	MOVE.W	#0,D1		; x coord
	MOVE.W	#0,D2		; y coord
	MOVE.B	#95,D0
	TRAP	#15
	RTS
*-------------------------------------------------------------
DICEPREP 
	*Load wav file into memory (not 68k)
 	
 	LEA	dice,A1			; load wav
	MOVE	#0,D1			; sound number 0
	MOVE	#71,D0
	TRAP	#15
	
	* Play dice.wav

	MOVE	#72,D0
	TRAP	#15
*-----------------------------------------------------------------------	
	*Delay the animation
	
	MOVE.L	#$50,D1		; delay the animation 50/100 of a second
	MOVE	#23,D0		; delay task
	TRAP	#15
*-----------------------------------------------------------------------
	*Set pen and fill color

	MOVE.L	#$00000000,D1	
	MOVE.B	#80,D0
	TRAP	#15


	MOVE.L	#$00FFFFFF,D1
	MOVE.B #81,D0
	TRAP	#15

	*Graphical representation of first die
	
	MOVE.W	#200,D1
	MOVE.W  #200,D2
	MOVE.W	#300,D3
	MOVE.W	#300,D4

	MOVE.B	#87,D0
	TRAP	#15		; 

	*Graphical representation of second die
	
	MOVE.W	#350,D1
	MOVE.W 	#200,D2
	MOVE.W	#450,D3
	MOVE.W	#300,D4
	
	MOVE.B	#87,D0
	TRAP	#15
	
DieFill	MOVE.L	#$00000000,D1
	MOVE.B #81,D0
	TRAP	#15
	
	RTS

*-------------------------------------------------------------
* Message for point
point
	
	*Set cursor position
	MOVE.W	#0002,D1
	MOVE.B	#11,D0
	TRAP	#15

 	LEA	prompt2,A1
	BSR	TASK95
 	
 	*Copy the contents of D6 into D7
 	MOVE	D6,D7
 	CLR	D6
 	

 	*While D6 is not equal (<NE>)to the number stored in D7
 	
	while.b D6 <NE> D7 do
	
		*Display the current value of "point"
		
		LEA	point1,A1
		MOVE.W	#0,D1
		MOVE.W	#435,D2
		MOVE.B	#95,D0
		TRAP #15
		
		MOVE.W	#$091D,D1	; Set cursor position (HEX WORKS BEST FOR TASK 11!)
		MOVE.B	#11,D0
		TRAP	#15

		
		EXG	D7,D1		; Momentarily switch the contents in registers for display purposes
	
		MOVE	#20,D0		; Display the number in D1.L on the screen
		MOVE.B	#$02,D2		; number is two columns wide
		TRAP	#15
		
		EXG	D1,D7		; The contents need to be switched back because the execution of the while loop depends on it



		*Set cursor position
		MOVE.W	#0002,D1
		MOVE.B	#11,D0
		TRAP	#15

		*Accept user input
 		MOVE.B	#5,D0
 		TRAP	#15

	 if.b d1 <EQ> #$72 then		; if the byte in register d1 is equal to the ASCII character "r"
		BSR 	DICEPREP
		BSR 	rand1
		BSR	firstIfSet
*-----------------------------------------------------------------------	
	*Delay the time between the generation of the first and second random numbers
	
	MOVE.L	#$16,D1		; delay the animation 50/100 of a second
	MOVE	#23,D0		; delay task
	TRAP	#15
*-----------------------------------------------------------------------

		BSR	rand2
		BSR	SecondIfSet
		ADD	D5,D6
		
		if.b D6 <EQ> #7 then	; if you roll a seven during point, you lose
			BSR	CLRPOINT	; Clear the point info
			LEA	lose1,A1
			BSR	TASK95	; display string in lose1 as a graphic

			*Set cursor position
			MOVE.W	#0002,D1
			MOVE.B	#11,D0
			TRAP	#15


			* Accept user input
			MOVE.B	#5,D0
			TRAP	#15
			
			if.b d1 <EQ> #$79 then	; if the byte in register d1 is equal to the ASCII character "y"

				BRA 	START
			else
				BRA	END
			endi
			
		endi
	  else
	  	BRA	END
	 endi
	endw
	
	BSR	CLRPOINT	; Clear the point info
	
	*D6 is equal to D7 when you break out of the loop, and the winning/play again message is displayed
	LEA	win,A1
	BSR	TASK95
	
	*Set cursor position
	MOVE.W	#0002,D1
	MOVE.B	#11,D0
	TRAP	#15

	*Accept User Input
	CLR	D1
	MOVE.B	#5,D0
	TRAP	#15
	
	*If d1 equals the ASCII code for "y" then you return to the start of the program, otherwise the program ends
	if.b d1 <EQ> #$79 then
	BRA	START
	else
	BRA	END
	endi
	
	RTS
*-------------------------------------------------------------
*Generate a random number from 1 to 6 (taken from lineart example)
rand1
	move.b	#8,d0
	trap	#15
	and.l	#$5FFFF,d1	; prevent overflow in divu
	divu	#6,d1	    	; time count / 6
	clr.w   d1
	swap	d1	        ; swap upper and lower words of D1 to put remainder in low word
	addq.w	#1,d1	    	; d1.w contains number from 1 to 6

	
	*Store the first random number to add later
	move.l	d1,d5
	
	RTS
*-------------------------------------------------------------
*Generate a random number from 1 to 6 (taken from lineart example)
rand2
	move.b	#8,d0
	trap	#15
	and.l	#$5FFFF,d1	; prevent overflow in divu
	divu	#6,d1	    	; time count / 6
	clr.w   d1
	swap	d1	        ; swap upper and lower words of D1 to put remainder in low word
	addq.w	#1,d1	    	; d1.w contains number from 1 to 6

	
	*Store the second random number to add later
	move.l	d1,d6
	RTS
*-------------------------------------------------------------


*Graphical representation for "1" (first die)
FIRST1	MOVE.W	#242,D1
	MOVE.W	#243,D2
	MOVE.W	#257,D3
	MOVE.W	#258,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	RTS
*--------------------------------------------------------------
*Graphical representation for "2" (first die)
FIRST2	MOVE.W	#210,D1		; upper dot
	MOVE.W	#210,D2
	MOVE.W	#225,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#275,D1		; lower dot
	MOVE.W	#275,D2
	MOVE.W	#290,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	RTS	
*--------------------------------------------------------------
*Graphical representation for "3" (first die)
FIRST3	MOVE.W	#210,D1		; upper dot
	MOVE.W	#210,D2
	MOVE.W	#225,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#242,D1	`	; middle dot
	MOVE.W	#243,D2
	MOVE.W	#257,D3
	MOVE.W	#258,D4
	
	MOVE.B	#88,D0
	TRAP	#15

	
	MOVE.W	#275,D1		; lower dot
	MOVE.W	#275,D2
	MOVE.W	#290,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15	
	RTS	
*--------------------------------------------------------------
*Graphical representation of "4" (first die)

FIRST4	MOVE.W	#210,D1		; upper left dot
	MOVE.W	#210,D2
	MOVE.W	#225,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#275,D1		; upper right dot
	MOVE.W	#210,D2
	MOVE.W	#290,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#275,D1		; lower right dot
	MOVE.W	#275,D2
	MOVE.W	#290,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#210,D1		; lower left dot
	MOVE.W	#275,D2
	MOVE.W	#225,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	RTS	
	
*--------------------------------------------------------------
*Graphical representation of "5" (first die)

FIRST5	MOVE.W	#210,D1		; upper left dot
	MOVE.W	#210,D2
	MOVE.W	#225,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#275,D1		; upper right dot
	MOVE.W	#210,D2
	MOVE.W	#290,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#242,D1	`	; middle dot
	MOVE.W	#243,D2
	MOVE.W	#257,D3
	MOVE.W	#258,D4
	
	MOVE.B	#88,D0
	TRAP	#15

	
	MOVE.W	#275,D1		; lower right dot
	MOVE.W	#275,D2
	MOVE.W	#290,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#210,D1		; lower left dot
	MOVE.W	#275,D2
	MOVE.W	#225,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	RTS	

*--------------------------------------------------------------
FIRST6	MOVE.W	#210,D1		; upper left dot
	MOVE.W	#210,D2
	MOVE.W	#225,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#275,D1		; upper right dot
	MOVE.W	#210,D2
	MOVE.W	#290,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#275,D1		; lower right dot
	MOVE.W	#275,D2
	MOVE.W	#290,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#210,D1		; lower left dot
	MOVE.W	#275,D2
	MOVE.W	#225,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#210,D1		; middle left dot
	MOVE.W	#242,D2
	MOVE.W	#225,D3
	MOVE.W	#257,D4
	
	MOVE.B	#88,D0
	TRAP	#15	
	
	MOVE.W	#275,D1		; middle right dot
	MOVE.W	#242,D2
	MOVE.W	#290,D3
	MOVE.W	#257,D4

	MOVE.B	#88,D0
	TRAP	#15
	RTS	
*-----------------------------------------------------------------------------------------------------------------------------------
*Graphical representation for "1" (second die)
SEC1	MOVE.W	#392,D1
	MOVE.W	#243,D2
	MOVE.W	#407,D3
	MOVE.W	#258,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	RTS
*--------------------------------------------------------------
*Graphical representation for "2" (second die)
SEC2	MOVE.W	#360,D1		; upper dot
	MOVE.W	#210,D2
	MOVE.W	#375,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#425,D1		; lower dot
	MOVE.W	#275,D2
	MOVE.W	#440,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	RTS	
*--------------------------------------------------------------
*Graphical representation for "3" (second die)
SEC3	MOVE.W	#360,D1		; upper dot
	MOVE.W	#210,D2
	MOVE.W	#375,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#392,D1	`	; middle dot
	MOVE.W	#243,D2
	MOVE.W	#407,D3
	MOVE.W	#258,D4
	
	MOVE.B	#88,D0
	TRAP	#15

	
	MOVE.W	#425,D1		; lower dot
	MOVE.W	#275,D2
	MOVE.W	#440,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15	
	RTS	

*--------------------------------------------------------------
*Graphical representation of "4" (second die)
SEC4	MOVE.W	#360,D1		; upper left dot
	MOVE.W	#210,D2
	MOVE.W	#375,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#425,D1		; upper right dot
	MOVE.W	#210,D2
	MOVE.W	#440,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#425,D1		; lower right dot
	MOVE.W	#275,D2
	MOVE.W	#440,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#360,D1		; lower left dot
	MOVE.W	#275,D2
	MOVE.W	#375,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	RTS		
*--------------------------------------------------------------
*Graphical representation of "5" (second die)
SEC5	MOVE.W	#360,D1		; upper left dot
	MOVE.W	#210,D2
	MOVE.W	#375,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#425,D1		; upper right dot
	MOVE.W	#210,D2
	MOVE.W	#440,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#392,D1	`	; middle dot
	MOVE.W	#243,D2
	MOVE.W	#407,D3
	MOVE.W	#258,D4
	
	MOVE.B	#88,D0
	TRAP	#15

	
	MOVE.W	#425,D1		; lower right dot
	MOVE.W	#275,D2
	MOVE.W	#440,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#360,D1		; lower left dot
	MOVE.W	#275,D2
	MOVE.W	#375,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	RTS		
*--------------------------------------------------------------
*Graphical representation of "6" (second die)
SEC6	MOVE.W	#360,D1		; upper left dot
	MOVE.W	#210,D2
	MOVE.W	#375,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#425,D1		; upper right dot
	MOVE.W	#210,D2
	MOVE.W	#440,D3
	MOVE.W	#225,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#425,D1		; lower right dot
	MOVE.W	#275,D2
	MOVE.W	#440,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#360,D1		; lower left dot
	MOVE.W	#275,D2
	MOVE.W	#375,D3
	MOVE.W	#290,D4
	
	MOVE.B	#88,D0
	TRAP	#15
	
	MOVE.W	#360,D1		; middle left dot
	MOVE.W	#242,D2
	MOVE.W	#375,D3
	MOVE.W	#257,D4
	
	MOVE.B	#88,D0
	TRAP	#15	
	
	MOVE.W	#425,D1		; middle right dot
	MOVE.W	#242,D2
	MOVE.W	#440,D3
	MOVE.W	#257,D4

	MOVE.B	#88,D0
	TRAP	#15
	RTS	
*-------------------------------------------------------------------------
firstIfSet

 if.b  d1 <EQ> #$1 then
	bsr	FIRST1
 endi

 if.b d1 <EQ> #$2 then
	bsr	FIRST2
 endi

 if.b d1 <EQ> #$3 then
	bsr	FIRST3
 endi

 if.b d1 <EQ> #$4 then
	bsr	FIRST4
 endi

 if.b d1 <EQ> #$5 then
	bsr	FIRST5
 endi

 if.b d1 <EQ> #$6 then
	bsr	FIRST6
 endi
 
 	RTS
*-------------------------------------------------------------------------
SecondIfSet

 if.b d1 <EQ> #$1 then
	bsr	SEC1
 endi

 if.b d1 <EQ> #$2 then
	bsr	SEC2
 endi

 if.b d1 <EQ> #$3 then
	bsr	SEC3
 endi

 if.b d1 <EQ> #$4 then
	bsr	SEC4
 endi

 if.b d1 <EQ> #$5 then
	bsr	SEC5
 endi

 if.b d1 <EQ> #$6 then
	bsr	SEC6
 endi
	
	RTS
*-------------------------------------------------------------------------
* Variables and Strings

dice	dc.b	'dice.wav',0
prompt1	DC.B	'Press "r" to roll or "q" to quit.             ',$0	; (33 characters)
prompt2 DC.B	'Point. Press "r" to roll again.               ',$0	; (31 characters)
lose1	DC.B	'Craps! You lose! Play again? ("y" or "n")     ',0	; (41 characters)
win	DC.B	'You Win! Play again? ("y" or "n")             ',$0	; (33 characters)
lose2	DC.B	'Snake Eyes! You lose! Play again? ("y" or "n")',$0	; (46 characters)
point1	DC.B	'Point:',$0						; (6 characters)
blank	DC.B	'            ',$0					; (8 characters)
TWODEL	DC.B	$7F,$7F,$0

option	DS.B	3
num1	
num2

Y	DC.B	0

	END	START		; last line of source



*~Font name~Courier New~
*~Font size~10~
*~Tab type~1~
*~Tab size~8~
